// saved as q_learning_one_subject_model.stan
data{
	int<lower=1> N;                    // Number of observations
	int<lower=2> C;                    // Number of response alternatices
	int<lower=0,upper=1> reset[N];     // Memory Reset
	int<lower=0> reward[N];            // List of reward amounts
	int<lower=1> choice[N];            // List of choices made
	int<lower=1> altern[N];            // List of alternatives not chosen
}
parameters{
	real z[2];
}
transformed parameters{
	real<lower=0,upper=1> alpha;
	real<lower=0> beta;

	alpha = inv_logit(z[1]);
	beta = exp(z[2]);
}
model{
	real mem[C];
	vector[2] cmem;
	vector[2] lsm;
	real p;

	z ~ normal(0,1);

	for ( n in 1:N ) {
		if (reset[n]==1) {
			for ( c in 1:C ) {
				mem[c] = 5;
			}
		}
		cmem[1] = pow(mem[choice[n]],beta);
		cmem[2] = pow(mem[altern[n]],beta);
		lsm = log_softmax(cmem);
		mem[choice[n]] = (1-alpha)*mem[choice[n]] + alpha*reward[n];
		target += lsm[1];
	}
}
